Subject: glibc 2.33's HWCAPS and GCC Function Multiversioning for performance

From: Léo Le Bouter <[email-masked]>
Date: Wed, 17 Mar 2021 19:59:51 +0100

Hello!

Please see:
- 
https://www.gnu.org/software/libc/manual/html_mono/libc.html#Hardware-Capability-Tunables
- https://www.phoronix.com/scan.php?page=news_item&px=glibc-hwcaps-RFC
- https://gcc.gnu.org/onlinedocs/gcc/Function-Multiversioning.html

This could help GNU Guix create binaries that include multiple code
paths for several CPU features in the same binary and selecting the
best at runtime when the binary is run.

It is the best fit for GNU Guix because it means we can still use
substitutes and profit from specialized optimizations without
parameterized packages or each user adding "-march=native" to CFLAGS
(breaking reproducibility).

Léo